      subroutine svvsmd(g,u1,u2,u3,u4,mat)
c----------------------------------------------------------------------c
c Returns a matrix element array for a quartic gauge-Higgs boson vertex 
c
c Input: u2,u3 - vectors,
c        u1,u4 - sclars,
c        g - a quartic scalar-gauge-boson coupling.
c All four momenta are cosidered as incoming to the vertex.
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 17 May, 2007; modified 
c----------------------------------------------------------------------c

      implicit none

      integer, parameter :: dp=kind(1.d0)

      complex(dp) :: u2(0:3),u3(0:3),u1(1),u4(1),mat,g

      mat=-g*u1(1)*u4(1)*(u2(0)*u3(0)-u2(1)*u3(1)
     &                   -u2(2)*u3(2)-u2(3)*u3(3))

      end subroutine svvsmd
