      subroutine gentop(nuni,nunf,npl,ntin,ntop,ncls,id,idr,ipl)
c----------------------------------------------------------------------c
c Generates topologies
c
c Karol Kolodziej, University of Silesia, karol.kolodziej@us.edu.pl
c 5-9 June, 2006; modified on 19 April 2007 (ncls added on the argument
c                 list)
c----------------------------------------------------------------------c

      use maxvals
      use extpart

      implicit none

      integer :: nunf,npl,ntin,ntop,ncls,id,idr

      integer :: nuni,it,blad,i,j,ii,jj,ipl

      integer :: temp(2),tplg(2)

      integer, allocatable :: tt(:,:),v1(:,:),v2(:,:)

      logical :: accept

      ntop=0

      if (npl == 4) then
       allocate (v1(1,3),stat=blad)
       allocate (v2(1,3),stat=blad)
       v1(1,:)=(/ 1, 2, 0/)
       v2(1,:)=(/ 3, 4, 0/)
       if (npl == next) then
        call checktop(v1,1,v2,1,ipl,ncls,id,idr,accept)
        if (accept) then
         ntop=ntop+1
        end if
       else
        ntop=ntop+1
        tplg(1)=1
        tplg(2)=1
        write(nunf,8015) tplg
        write(nunf,8010) v1(1,:)
        write(nunf,8010) v2(1,:)
       end if
       v1(1,:)=(/ 1, 3, 0/)
       v2(1,:)=(/ 2, 4, 0/)
       if (npl == next) then
        call checktop(v1,1,v2,1,ipl,ncls,id,idr,accept)
        if (accept) then
         ntop=ntop+1
        end if
       else
        ntop=ntop+1
        tplg(1)=1
        tplg(2)=1
        write(nunf,8015) tplg
        write(nunf,8010) v1(1,:)
        write(nunf,8010) v2(1,:)
       end if
       v1(1,:)=(/ 1, 4, 0/)
       v2(1,:)=(/ 2, 3, 0/)
       if (npl == next) then
        call checktop(v1,1,v2,1,ipl,ncls,id,idr,accept)
        if (accept) then
         ntop=ntop+1
        end if
       else
        ntop=ntop+1
        tplg(1)=1
        tplg(2)=1
        write(nunf,8015) tplg
        write(nunf,8010) v1(1,:)
        write(nunf,8010) v2(1,:)
       end if
       v1(1,:)=(/ 1, 2, 3/)
       v2(1,:)=(/ 4, 0, 0/)
       if (npl == next) then
        call checktop(v1,1,v2,1,ipl,ncls,id,idr,accept)
        if (accept) then
         ntop=ntop+1
        end if
       else
        ntop=ntop+1
        tplg(1)=1
        tplg(2)=1
        write(nunf,8015) tplg
        write(nunf,8010) v1(1,:)
        write(nunf,8010) v2(1,:)
       end if
       deallocate (v1,v2,stat=blad)

 8010 format(3(i3))
 8015 format(2(i4))
 8020 format(4(i3))

      else 
       if (npl == 5) then
        ntin=3
       end if

       do it=1,ntin
        read(nuni,8015) temp
        allocate (v1(temp(1),3),stat=blad)
        allocate (v2(temp(2),3),stat=blad)
        do i=1,temp(1)
         read(nuni,8010) v1(i,:)
        end do
        do i=1,temp(2)
         read(nuni,8010) v2(i,:)
        end do
        do i=1,temp(1)
         do j=1,3
          if (j == 1) then
           tplg(1)=temp(1)+1
           tplg(2)=temp(2)
           allocate (tt(tplg(1),3),stat=blad)
           do ii=1,i-1
            tt(ii,:)=v1(ii,:)
           end do
           tt(i,:)=(/v1(i,1),npl, 0/)
           tt(i+1,:)=(/-i,v1(i,2),v1(i,3)/)
           do ii=i+1,temp(1)
            do jj=1,3
             if (v1(ii,jj) < 0 .and. abs(v1(ii,jj)) >= i) then
              tt(ii+1,jj)=v1(ii,jj)-1
             else
              tt(ii+1,jj)=v1(ii,jj)
             end if
            end do
           end do
           if (npl == next) then
            call checktop(tt,tplg(1),v2,temp(2),ipl,ncls,id,idr,accept)
            if (accept) then
             ntop=ntop+1
            end if
           else
            ntop=ntop+1
            write(nunf,8015) tplg
            do ii=1,tplg(1)
             write(nunf,8010) tt(ii,:)
            end do
            do ii=1,temp(2)
             write(nunf,8010) v2(ii,:)
            end do
           end if
           deallocate (tt,stat=blad)
          else if (j == 2) then
           tplg(1)=temp(1)+1
           tplg(2)=temp(2)
           allocate (tt(tplg(1),3),stat=blad)
           do ii=1,i-1
            tt(ii,:)=v1(ii,:)
           end do
           tt(i,:)=(/v1(i,2),npl, 0/)
           tt(i+1,:)=(/v1(i,1),-i,v1(i,3)/)
           do ii=i+1,temp(1)
            do jj=1,3
             if (v1(ii,jj) < 0 .and. abs(v1(ii,jj)) >= i) then
              tt(ii+1,jj)=v1(ii,jj)-1
             else
              tt(ii+1,jj)=v1(ii,jj)
             end if
            end do
           end do
           if (npl == next) then
            call checktop(tt,tplg(1),v2,temp(2),ipl,ncls,id,idr,accept)
            if (accept) then
             ntop=ntop+1
            end if
           else
            ntop=ntop+1
            write(nunf,8015) tplg
            do ii=1,tplg(1)
             write(nunf,8010) tt(ii,:)
            end do
            do ii=1,temp(2)
             write(nunf,8010) v2(ii,:)
            end do
           end if
           deallocate (tt,stat=blad)
          else if (j == 3) then
           if (v1(i,3) == 0) then
            if (i == temp(1)) then
             tplg(1)=temp(1)+1
             tplg(2)=temp(2)
             allocate (tt(tplg(1),3),stat=blad)
             do ii=1,i-1
              tt(ii,:)=v1(ii,:)
             end do
             tt(i,:)=v1(i,:)
             tt(i+1,:)=(/-i, npl, 0/)
             do ii=i+1,temp(1)
              do jj=1,3
               if (v1(ii,jj) < 0 .and. abs(v1(ii,jj)) >= i) then
                tt(ii+1,jj)=v1(ii,jj)-1
               else
                tt(ii+1,jj)=v1(ii,jj)
               end if
              end do
             end do
             if (npl == next) then
              call checktop(tt,tplg(1),v2,temp(2),ipl,ncls,id,idr,
     &                                                     accept)
              if (accept) then
               ntop=ntop+1
              end if
             else
              ntop=ntop+1
              write(nunf,8015) tplg
              do ii=1,tplg(1)
               write(nunf,8010) tt(ii,:)
              end do
              do ii=1,temp(2)
               write(nunf,8010) v2(ii,:)
              end do
             end if
             deallocate (tt,stat=blad)
            end if
            tplg(1)=temp(1)
            tplg(2)=temp(2)
            allocate (tt(tplg(1),3),stat=blad)
            do ii=1,i-1
             tt(ii,:)=v1(ii,:)
            end do
            tt(i,:)=(/v1(i,1),v1(i,2),npl/)
            do ii=i+1,temp(1)
             do jj=1,3
              tt(ii,jj)=v1(ii,jj)
             end do
            end do
            if (npl == next) then
             call checktop(tt,tplg(1),v2,temp(2),ipl,ncls,id,idr,accept)
             if (accept) then
              ntop=ntop+1
             end if
            else
             ntop=ntop+1
             write(nunf,8015) tplg
             do ii=1,tplg(1)
              write(nunf,8010) tt(ii,:)
             end do
             do ii=1,temp(2)
              write(nunf,8010) v2(ii,:)
             end do
            end if
            deallocate (tt,stat=blad)
           else ! v1(i,3) /= 0
            if (i == temp(1)) then
             tplg(1)=temp(1)+1
             tplg(2)=temp(2)
             allocate (tt(tplg(1),3),stat=blad)
             do ii=1,i-1
              tt(ii,:)=v1(ii,:)
             end do
             tt(i,:)=v1(i,:)
             tt(i+1,:)=(/-i, npl, 0/)
             if (npl == next) then
              call checktop(tt,tplg(1),v2,temp(2),ipl,ncls,id,idr,
     &                                                       accept)
              if (accept) then
               ntop=ntop+1
              end if
             else
              ntop=ntop+1
              write(nunf,8015) tplg
              do ii=1,tplg(1)
               write(nunf,8010) tt(ii,:)
              end do
              do ii=1,temp(2)
               write(nunf,8010) v2(ii,:)
              end do
             end if
             deallocate (tt,stat=blad)
            end if
            tplg(1)=temp(1)+1
            tplg(2)=temp(2)
            allocate (tt(tplg(1),3),stat=blad)
            do ii=1,i-1
             tt(ii,:)=v1(ii,:)
            end do
            tt(i,:)=(/v1(i,3),npl, 0/)
            tt(i+1,:)=(/v1(i,1),v1(i,2),-i/)
            do ii=i+1,temp(1)
             do jj=1,3
              if (v1(ii,jj) < 0 .and. abs(v1(ii,jj)) >= i) then
               tt(ii+1,jj)=v1(ii,jj)-1
              else
               tt(ii+1,jj)=v1(ii,jj)
              end if
             end do
            end do
            if (npl == next) then
             call checktop(tt,tplg(1),v2,temp(2),ipl,ncls,id,idr,accept)
             if (accept) then
              ntop=ntop+1
             end if
            else
             ntop=ntop+1
             write(nunf,8015) tplg
             do ii=1,tplg(1)
              write(nunf,8010) tt(ii,:)
             end do
             do ii=1,temp(2)
              write(nunf,8010) v2(ii,:)
             end do
            end if
            deallocate (tt,stat=blad)
           end if
          end if
         end do
        end do
        do i=1,temp(2)
         do j=1,3
          if (j == 1) then
           tplg(1)=temp(1)
           tplg(2)=temp(2)+1
           allocate (tt(tplg(2),3),stat=blad)
           do ii=1,i-1
            tt(ii,:)=v2(ii,:)
           end do
           tt(i,:)=(/v2(i,1),npl, 0/)
           tt(i+1,:)=(/-i,v2(i,2),v2(i,3)/)
           do ii=i+1,temp(2)
            do jj=1,3
c             if (v2(ii,jj) < 0) then
             if (v2(ii,jj) < 0 .and. abs(v2(ii,jj)) >= i) then
              tt(ii+1,jj)=v2(ii,jj)-1
             else
              tt(ii+1,jj)=v2(ii,jj)
             end if
            end do
           end do
           if (npl == next) then
            call checktop(v1,temp(1),tt,tplg(2),ipl,ncls,id,idr,accept)
            if (accept) then
             ntop=ntop+1
            end if
           else
            ntop=ntop+1
            write(nunf,8015) tplg
            do ii=1,temp(1)
             write(nunf,8010) v1(ii,:)
            end do
            do ii=1,tplg(2)
             write(nunf,8010) tt(ii,:)
            end do
           end if
           deallocate (tt,stat=blad)
          else if (j == 2) then
           tplg(1)=temp(1)
           tplg(2)=temp(2)+1
           allocate (tt(tplg(2),3),stat=blad)
           do ii=1,i-1
            tt(ii,:)=v2(ii,:)
           end do
           tt(i,:)=(/v2(i,2),npl, 0/)
           tt(i+1,:)=(/v2(i,1),-i,v2(i,3)/)
           do ii=i+1,temp(2)
            do jj=1,3
c             if (v2(ii,jj) < 0) then
             if (v2(ii,jj) < 0 .and. abs(v2(ii,jj)) >= i) then
              tt(ii+1,jj)=v2(ii,jj)-1
             else
              tt(ii+1,jj)=v2(ii,jj)
             end if
            end do
           end do
           if (npl == next) then
            call checktop(v1,temp(1),tt,tplg(2),ipl,ncls,id,idr,accept)
            if (accept) then
             ntop=ntop+1
            end if
           else
            ntop=ntop+1
            write(nunf,8015) tplg
            do ii=1,temp(1)
             write(nunf,8010) v1(ii,:)
            end do
            do ii=1,tplg(2)
             write(nunf,8010) tt(ii,:)
            end do
           end if
           deallocate (tt,stat=blad)
          else if (j == 3) then
           if (v2(i,3) == 0) then
            tplg(1)=temp(1)
            tplg(2)=temp(2)
            allocate (tt(tplg(2),3),stat=blad)
            do ii=1,i-1
             tt(ii,:)=v2(ii,:)
            end do
            tt(i,:)=(/v2(i,1),v2(i,2),npl/)
            do ii=i+1,temp(2)
             do jj=1,3
              tt(ii,jj)=v2(ii,jj)
             end do
            end do
            if (npl == next) then
             call checktop(v1,temp(1),tt,tplg(2),ipl,ncls,id,idr,accept)
             if (accept) then
              ntop=ntop+1
             end if
            else
             ntop=ntop+1
             write(nunf,8015) tplg
             do ii=1,temp(1)
              write(nunf,8010) v1(ii,:)
             end do
             do ii=1,tplg(2)
              write(nunf,8010) tt(ii,:)
             end do
            end if
            deallocate (tt,stat=blad)
           else ! v2(i,3) /= 0
            tplg(1)=temp(1)
            tplg(2)=temp(2)+1
            allocate (tt(tplg(2),3),stat=blad)
            do ii=1,i-1
             tt(ii,:)=v2(ii,:)
            end do
            tt(i,:)=(/v2(i,3),npl, 0/)
            tt(i+1,:)=(/v2(i,1),v2(i,2),-i/)
            do ii=i+1,temp(2)
             do jj=1,3
c              if (v2(ii,jj) < 0) then
              if (v2(ii,jj) < 0 .and. abs(v2(ii,jj)) >= i) then
               tt(ii+1,jj)=v2(ii,jj)-1
              else
               tt(ii+1,jj)=v2(ii,jj)
              end if
             end do
            end do
            if (npl == next) then
             call checktop(v1,temp(1),tt,tplg(2),ipl,ncls,id,idr,accept)
             if (accept) then
              ntop=ntop+1
             end if
            else
             ntop=ntop+1
             write(nunf,8015) tplg
             do ii=1,temp(1)
              write(nunf,8010) v1(ii,:)
             end do
             do ii=1,tplg(2)
              write(nunf,8010) tt(ii,:)
             end do
            end if
            deallocate (tt,stat=blad)
           end if
          end if
         end do
        end do
        deallocate (v1,v2,stat=blad)
       end do

      if (npl == 5) then
       allocate (v1(1,3),stat=blad)
       allocate (v2(1,3),stat=blad)
       v1(1,:)=(/ 2, 3, 4/)
       v2(1,:)=(/ 1, 5, 0/)
       if (npl == next) then
        call checktop(v1,1,v2,1,ipl,ncls,id,idr,accept)
        if (accept) then
         ntop=ntop+1
        end if
       else
        ntop=ntop+1
        tplg(1)=1
        tplg(2)=1
        write(nunf,8015) tplg
        write(nunf,8010) v1(1,:)
        write(nunf,8010) v2(1,:)
       end if
       v1(1,:)=(/ 1, 3, 4/)
       v2(1,:)=(/ 2, 5, 0/)
       if (npl == next) then
        call checktop(v1,1,v2,1,ipl,ncls,id,idr,accept)
        if (accept) then
         ntop=ntop+1
        end if
       else
        ntop=ntop+1
        tplg(1)=1
        tplg(2)=1
        write(nunf,8015) tplg
        write(nunf,8010) v1(1,:)
        write(nunf,8010) v2(1,:)
       end if
       v1(1,:)=(/ 1, 2, 4/)
       v2(1,:)=(/ 3, 5, 0/)
       if (npl == next) then
        call checktop(v1,1,v2,1,ipl,ncls,id,idr,accept)
        if (accept) then
         ntop=ntop+1
        end if
       else
        ntop=ntop+1
        tplg(1)=1
        tplg(2)=1
        write(nunf,8015) tplg
        write(nunf,8010) v1(1,:)
        write(nunf,8010) v2(1,:)
       end if
       v1(1,:)=(/ 1, 2, 3/)
       v2(1,:)=(/ 4, 5, 0/)
       if (npl == next) then
        call checktop(v1,1,v2,1,ipl,ncls,id,idr,accept)
        if (accept) then
         ntop=ntop+1
        end if
       else
        ntop=ntop+1
        tplg(1)=1
        tplg(2)=1
        write(nunf,8015) tplg
        write(nunf,8010) v1(1,:)
        write(nunf,8010) v2(1,:)
       end if
       deallocate (v1,v2,stat=blad)
      end if

      end if

c       if (npl > 4) then
c        write(*,*)'zamkniety',nuni
c        close(nuni)
c       end if
c       if (npl < next) then
c        write(*,*)'zamkniety',nunf
c        close(nunf)
c       end if


      end subroutine gentop
