      function crosskk(x,ndim)
c----------------------------------------------------------------------c
c The unpolarized cross section
c
c Input:  x(ndim) - random numbers supplied by carlos.
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 23 March, 2006, modiffied on 15 Nov. 2007;
c                              29 Oct. 2008;
c                              31 Jul. 2009
c----------------------------------------------------------------------c
      use mathprms 
      use inprms
      use drivekk
      use distribs
      use partcls
      use kincuts

      implicit none

      integer :: ndim,i,j,ifrst=1,istf,imxup=0

      real(dp) :: crosskk,x(ndim),ecm0=zero,flux,dlinv,dlips,
     &            p(0:3,nepl),mat2,cps,phi(nmcs),pij(0:3),emisst

      real :: y(nmcs),rand

      character(80) ind

      save ifrst,cps,ecm0,flux,p,imxup

      if (ifrst == 1) then
       cps=(twopi)**(4-3*(nepl-nisp))
       ifrst=0
      end if

      if (ecm /= ecm0) then
       call kinin(ecm,m(1:2),p(:,1:2),flux)
       ecm0=ecm
      end if

      call kincls(ikin,1,ecm,p,x,ndim,dlinv)

      if (dlinv > 0.d0) then ! Introduced on 15 Nov. 2007

      if (icuts == 1) then
       call impcuts
       if (istf == 0) then
        crosskk=0.d0
        return
       end if
      end if ! icuts

      call psnkk(ikin,ecm,p,x,ndim,dlinv)

      dlips=cps/dlinv

c MC summing over polarizations:

      if (nmcs > 0) then
       call ranlux(y,nmcs)
       do i=1,nmcs
        phi(i)=twopi*y(i)
       end do
      end if

      call matrixel(p,phi,mat2)

c      mat2=1.d0

      crosskk=convc/flux*ralpw0*mat2*dlips

c ralpw0=  1, if no external photons are present
c ralpw0= (alpha_0/alpha_w)^n - for n external photons

      icall=icall+1

      if (imc == 0) then
c       if (crosskk > crmax) then
       if (crosskk-crmax > 1.d-14*crmax) then
        crmax=crosskk
        imxtot=1
        if (iscan == 0) imxup=1
       end if
      end if


      if (idis == 1 .and. iscan == 0) then
       call calcdis(p,crosskk)
      end if

      if (imc == 0 .and. iscan == 0) then
c       call random_number(rand)
       call ranlux(rand,1)
       if (crosskk > rand*crmax) then
        ieff=ieff+1
        if (imxup == 1) then
         write(11,'(a,e12.5)') '# The maximum value of the cross '
     &      //'section changed to', crmax
         imxup=0
         close(11)
         write(ind,'(f10.1)') ecm
         open(unit=11,file='mc_events.'//trim(adjustl(ind)),
     &                            status='replace',action='write')
         ieff=0
        end if
        write(ind,'(i16)') ieff
        write(11,'(a)') '# Event No. '//trim(adjustl(ind))//':'
        do i=nisp+1,nepl
         write(ind,'(i2)') i
         write(11,'(a,4(e16.8))') 'p_'//trim(adjustl(ind))//'=',p(:,i)
        end do
       end if
      end if

      else            ! Introduced on 15 Nov. 2007
       crosskk=zero
       return
      end if  !  dlinv

      contains

      subroutine impcuts
       istf=1
       if (ictlb == 1) then
        do i=nisp+1,nepl
         if (expl(i) == 'l') then
          if (abs(p(3,i)/sqrt(p(1,i)**2+p(2,i)**2+p(3,i)**2)) > ctlb) 
     &                                                           then
           istf=0
           return
          end if
         end if
        end do
       end if
       if (ictqb == 1) then
        do i=nisp+1,nepl
         if (expl(i) == 'q') then
          if (abs(p(3,i)/sqrt(p(1,i)**2+p(2,i)**2+p(3,i)**2)) > ctqb) 
     &                                                           then
           istf=0
           return
          end if
         end if
        end do
       end if
       if (ictgb == 1) then
        do i=nisp+1,nepl
         if (expl(i) == 'g') then
          if (abs(p(3,i)/sqrt(p(1,i)**2+p(2,i)**2+p(3,i)**2)) > ctgb) 
     &                                                           then
           istf=0
           return
          end if
         end if
        end do
       end if
       if (ictab == 1) then
        do i=nisp+1,nepl
         if (expl(i) == 'a') then
          if (abs(p(3,i)/sqrt(p(1,i)**2+p(2,i)**2+p(3,i)**2)) > ctab) 
     &                                                           then
           istf=0
           return
          end if
         end if
        end do
       end if
       if (ictal == 1) then
        do i=nisp+1,nepl
         if (expl(i) == 'a') then
          do j=nisp+1,nepl
           if (expl(j) == 'l') then
            if ((p(1,i)*p(1,j)+p(2,i)*p(2,j)+p(3,i)*p(3,j))/sqrt(
     &          (p(1,i)*p(1,i)+p(2,i)*p(2,i)+p(3,i)*p(3,i))
     &         *(p(1,j)*p(1,j)+p(2,j)*p(2,j)+p(3,j)*p(3,j))) > ctal)
     &                                                           then
             istf=0
             return
            end if
           end if
          end do
         end if
        end do
       end if
       if (ictaq == 1) then
        do i=nisp+1,nepl
         if (expl(i) == 'a') then
          do j=nisp+1,nepl
           if (expl(j) == 'q') then
            if ((p(1,i)*p(1,j)+p(2,i)*p(2,j)+p(3,i)*p(3,j))/sqrt(
     &          (p(1,i)*p(1,i)+p(2,i)*p(2,i)+p(3,i)*p(3,i))
     &         *(p(1,j)*p(1,j)+p(2,j)*p(2,j)+p(3,j)*p(3,j))) > ctaq)
     &                                                           then
             istf=0
             return
            end if
           end if
          end do
         end if
        end do
       end if
       if (ictqq == 1) then
        do i=nisp+1,nepl-1
         if (expl(i) == 'q') then
          do j=i+1,nepl
           if (expl(j) == 'q') then
            if ((p(1,i)*p(1,j)+p(2,i)*p(2,j)+p(3,i)*p(3,j))/sqrt(
     &          (p(1,i)*p(1,i)+p(2,i)*p(2,i)+p(3,i)*p(3,i))
     &         *(p(1,j)*p(1,j)+p(2,j)*p(2,j)+p(3,j)*p(3,j))) > ctqq)
     &                                                           then
             istf=0
             return
            end if
           end if
          end do
         end if
        end do
       end if
       if (ictlq == 1) then
        do i=nisp+1,nepl
         if (expl(i) == 'l') then
          do j=nisp+1,nepl
           if (expl(j) == 'q') then
            if ((p(1,i)*p(1,j)+p(2,i)*p(2,j)+p(3,i)*p(3,j))/sqrt(
     &          (p(1,i)*p(1,i)+p(2,i)*p(2,i)+p(3,i)*p(3,i))
     &         *(p(1,j)*p(1,j)+p(2,j)*p(2,j)+p(3,j)*p(3,j))) > ctlq)
     &                                                           then
             istf=0
             return
            end if
           end if
          end do
         end if
        end do
       end if
       if (ictlg == 1) then
        do i=nisp+1,nepl
         if (expl(i) == 'l') then
          do j=nisp+1,nepl
           if (expl(j) == 'g') then
            if ((p(1,i)*p(1,j)+p(2,i)*p(2,j)+p(3,i)*p(3,j))/sqrt(
     &          (p(1,i)*p(1,i)+p(2,i)*p(2,i)+p(3,i)*p(3,i))
     &         *(p(1,j)*p(1,j)+p(2,j)*p(2,j)+p(3,j)*p(3,j))) > ctlg)
     &                                                           then
             istf=0
             return
            end if
           end if
          end do
         end if
        end do
       end if
       if (ictll == 1) then
        do i=nisp+1,nepl-1
         if (expl(i) == 'l') then
          do j=i+1,nepl
           if (expl(j) == 'l') then
            if ((p(1,i)*p(1,j)+p(2,i)*p(2,j)+p(3,i)*p(3,j))/sqrt(
     &          (p(1,i)*p(1,i)+p(2,i)*p(2,i)+p(3,i)*p(3,i))
     &         *(p(1,j)*p(1,j)+p(2,j)*p(2,j)+p(3,j)*p(3,j))) > ctll)
     &                                                           then
             istf=0
             return
            end if
           end if
          end do
         end if
        end do
       end if
       if (ienl == 1) then
        do i=nisp+1,nepl
         if (expl(i) == 'l') then
          if (p(0,i) < ecutl) then
           istf=0
           return
          end if
         end if
        end do
       end if
       if (iemt == 1) then
        emisst=0.d0
        do i=nisp+1,nepl
         if (expl(i) == 'n') then
          emisst=emisst+sqrt(p(1,i)**2+p(2,i)**2)
          if (emisst < ecutt) then
           istf=0
           return
          end if
         end if
        end do
       end if
       if (ienq == 1) then
        do i=nisp+1,nepl
         if (expl(i) == 'q') then
          if (p(0,i) < ecutq) then
           istf=0
           return
          end if
         end if
        end do
       end if
       if (ienb == 1) then
        do i=nisp+1,nepl
         if (expc(i)(1:1) == 'b') then
          if (p(0,i) < ecutb) then
           istf=0
           return
          end if
         end if
        end do
       end if    ! 31 July, 2009
       if (ieng == 1) then
        do i=nisp+1,nepl
         if (expl(i) == 'g') then
          if (p(0,i) < ecutg) then
           istf=0
           return
          end if
         end if
        end do
       end if
       if (iena == 1) then
        do i=nisp+1,nepl
         if (expl(i) == 'a') then
          if (p(0,i) < ecuta) then
           istf=0
           return
          end if
         end if
        end do
       end if
       if (imqq == 1) then
        do i=nisp+1,nepl-1
         if (expl(i) == 'q') then
          do j=i+1,nepl
           if (expl(j) == 'q') then
            pij=p(:,i)+p(:,j)
            if ((pij(0)-pij(3))*(pij(0)+pij(3))-pij(1)*pij(1)
     &          -pij(2)*pij(2) < mqq*mqq) then
             istf=0
             return
            end if
           end if
          end do
         end if
        end do
       end if
       if (imbb == 1) then
        do i=nisp+1,nepl-1
         if (expc(i)(1:1) == 'b') then
          do j=i+1,nepl
           if (expc(j)(1:1) == 'b') then
            pij=p(:,i)+p(:,j)
            if ((pij(0)-pij(3))*(pij(0)+pij(3))-pij(1)*pij(1)
     &          -pij(2)*pij(2) < mbb*mbb) then
             istf=0
             return
            end if
           end if
          end do
         end if
        end do
       end if
       if (imjj == 1) then
        do i=nisp+1,nepl-1
         if (expl(i) == 'q' .or. expl(i) == 'g') then
          do j=i+1,nepl
           if (expl(j) == 'q' .or. expl(j) == 'g') then
            pij=p(:,i)+p(:,j)
            if ((pij(0)-pij(3))*(pij(0)+pij(3))-pij(1)*pij(1)
     &          -pij(2)*pij(2) < mjj*mjj) then
             istf=0
             return
            end if
           end if
          end do
         end if
        end do
       end if
       if (imll == 1) then
        do i=nisp+1,nepl
         if (expl(i) == 'l') then
          do j=i+1,nepl
           if (expl(j) == 'l') then
            pij=p(:,i)+p(:,j)
            if ((pij(0)-pij(3))*(pij(0)+pij(3))-pij(1)*pij(1)
     &          -pij(2)*pij(2) < mll*mll) then
             istf=0
             return
            end if
           end if
          end do
         end if
        end do
       end if
      end subroutine impcuts

      end function crosskk
